unit VitejteDemo;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants,
  System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, VitejteInterface;

type
  TForm17 = class(TForm)
    ListBox1: TListBox;
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    Memo1: TMemo;
    Pacienti: TLabel;
    Memo2: TMemo;
    Zpravy: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }

    FCommHandle: TCommHandle;
    FCallbackHandle: TCallbackHandle;

    procedure updatePatients();
  public
    { Public declarations }
  end;

procedure onChanged(ACustomPayload: Pointer); stdcall;
procedure onStateChanged(ACustomPayload: Pointer; aState: Integer;
  aUntil: TTime); stdcall;
procedure onError(ACustomPayload: Pointer; AMessage: PAnsiChar); stdcall;

var
  Form17: TForm17;

implementation

{$R *.dfm}

procedure onChanged(ACustomPayload: Pointer); stdcall;
var
  form: TForm17;
  patients: PPacientArray;
  patientCount: Integer;
begin
  form := TForm17(ACustomPayload);
  TThread.Synchronize(nil,
    procedure
    var
      i: Integer;
    begin
      form.Memo1.Lines.Clear();
      getPat(form.FCommHandle, patients, patientCount);
      try
        for i := 0 to patientCount - 1 do
        begin
          form.Memo1.Lines.Add('Jmeno: ' + patients[i]^.jmeno + ' ' +
            patients[i]^.prijmeni + ' id: ' + IntToStr(patients[i]^.id));
        end;
      finally
        freePatients(patients, patientCount);
      end;
    end);
end;

procedure onStateChanged(ACustomPayload: Pointer; aState: Integer;
aUntil: TTime); stdcall;
var
  form: TForm17;
begin
  form := TForm17(ACustomPayload);
  TThread.Synchronize(nil,
    procedure
    begin
      form.Memo2.Lines.Add('State change: ' + IntToStr(aState));
    end);
end;

procedure onError(ACustomPayload: Pointer; AMessage: PAnsiChar); stdcall;
var
  form: TForm17;
begin
  form := TForm17(ACustomPayload);
  TThread.Synchronize(nil,
    procedure
    begin
      form.Memo2.Lines.Add('Error: ' + ansistring(AMessage));
    end);
end;

procedure TForm17.Button1Click(Sender: TObject);
var
  deviceList: PStringArray;
  deviceListSize, i: Integer;
begin
  findDevices(FCommHandle, deviceList, deviceListSize);
  try
    ListBox1.Items.Clear();
    for i := 0 to deviceListSize - 1 do
    begin
      ListBox1.Items.Add(string(ansistring(deviceList[i])));
    end;
  finally
    freeStringArray(deviceList, deviceListSize);
  end;
end;

procedure TForm17.Button2Click(Sender: TObject);
begin
  if ListBox1.ItemIndex <> -1 then
  begin
    setDevice(FCommHandle,
      PAnsiChar(ansistring(ListBox1.Items[ListBox1.ItemIndex])));
    setPatientsChangedCallback(FCallbackHandle, onChanged, self);
    setErrorCallback(FCallbackHandle, onError, self);
    setStateChangedCallback(FCallbackHandle, onStateChanged, self);
    setCallbackForComm(FCommHandle, FCallbackHandle);
    registerClient(FCommHandle, 44444, '0');
    startPingTimer(FCommHandle);
  end;
end;

procedure TForm17.FormCreate(Sender: TObject);
begin
  FCommHandle := createCommunicationHandle();
  FCallbackHandle := createCallbackHandle();
end;

procedure TForm17.FormDestroy(Sender: TObject);
begin
  unRegisterClient(FCommHandle);
  stopPingTimer(FCommHandle);
  deleteCommunicationHandle(FCommHandle);
  deleteCallbackHandle(FCallbackHandle);
end;

procedure TForm17.updatePatients;
begin

end;

end.
