# Vitejte knihovna

Knihovna pro komunikaci se zařízením Vítejte. Udržuje komunikaci s Vítejte a udržuje si aktuální seznam pacientů v čekárně. 

Popis jednotlivých funkcí je v `dll/VitejteInterface.pas`.

Ve složkách `C++ demo` a `Delphi demo` jsou ukázky použití knihovny pro základní komunikaci. Složka `simulator` obsahuji aplikaci simulující funkci zařízení Vítejte.

Základní použití je následující: 
* `createCommunicationHandle()` pro vytvoření objektu pro komunikaci.
* `createCallbackHandle()` pro vytvoření objektu udržující callbacky.
* `findDevices(...)` instruuje knihovnu k nalezení zařízení na síti. Blokující operace.
* `setDevice(...)` interně nastaví jedno z nalezených zařízení pro další komunikaci. 
* `registerClient(...)` registrace knihovny jako klienta přijímající události o změnách stavu zařízení a změnách ve frontě. Při ukončení nutno odregistrovat - `unRegisterClient(...)`.
* `startPingTimer(...)` pro aktivaci vlákna, které periodicky kontroluje validitu fronty a případně vyžádá změny, pokud některé události nebyly doručeny. Nutno při odpojení vypnout pomocí `stopPingTimer(...)`.
* Nastavení callbacků pomocí funkcí `setPatientsChangedCallback(...)`, `setStateChangedCallback(...)`, `setErrorCallback(...)`. Tyto funkce přijímají `void *` argument pro libovolná uživatelská data, která budou při volání callbacku předána. Po nastavení callbacků je nutné je registrovat pomocí `setCallbackForCom(...)`.
* !**Všechna data alokována knihovnou je nutné uvolňovat pomocí funkcí `freeStringArray(...)`, `freeString(...)`, `freePatients(...)`, `deleteCallbackHandle(...)`, `deleteCommunicationHandle(...)`**.
* `getPat(...)` vrátí informace o pacientech, kteří jsou momentálně ve frontě. Předpokládá se volání pouze po registraci, následné změny pomocí notifikací (callbacků).

